      subroutine kinkk7(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=7
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3
      real(dp) :: sqsl1,sqsl2,sqsl3
      real(dp) :: sqsu1,sqsu2,sqsu3
      real(dp) :: sqs1,sqs2,sqs3
      real(dp) :: ds1,ds2,ds3
      real(dp) :: s1,s2,s3
      real(dp) :: dl1,dl2,dl3
 
      if (ikin <= nt155) then                                                   
       sqsl1=m(3)+m(6)                                                          
       sqsl2=sqsl1+m(7)                                                         
       sqsl3=m(4)+m(5)                                                          
       if (imom /= 1) then                                                      
        q1=p(:,3)+p(:,6)                                                        
        q2=q1+p(:,7)                                                            
        q3=p(:,4)+p(:,5)                                                        
       end if                                                                   
       if (ikin == 309) then                                                    
       sqsu2=ecm-sqsl3                                                          
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)                 
       sqsu1=sqs2-m(7)                                                          
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)                                          
       if (imom == 1) then                                                      
        s1=ds1*x(1)+sqsl1*sqsl1                                                 
       else                                                                     
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)                  
       end if                                                                   
       sqs1=sqrt(s1)                                                            
       sqsu3=ecm-sqs2                                                           
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)                 
       end if                                                                   
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(8:9),p(:,4),p(:,5),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt156) then
       sqsl1=m(3)+m(6)
       sqsl2=m(7)+sqsl1
       sqsl3=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,7)+q1
        q3=p(:,4)+p(:,5)
       end if
       if (ikin == 310) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,me,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(6:7),p(:,7),q1,dl2)
       call kinff(imom,sqs3,m(4),m(5),x(8:9),p(:,4),p(:,5),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt157) then
       sqsl1=m(3)+m(6)
       sqsl2=sqsl1+m(7)
       sqsl3=m(4)+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=q1+p(:,7)
        q3=p(:,4)+p(:,5)
       end if
       if (ikin == 311) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,me,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(4),m(5),x(8:9),p(:,4),p(:,5),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt161) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=q2+p(:,7)
       end if
       if (ikin == 312) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,me,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt162) then
       sqsl1=m(4)+m(7)
       sqsl2=sqsl1+m(5)
       sqsl3=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,7)
        q2=q1+p(:,5)
        q3=p(:,3)+p(:,6)
       end if
       if (ikin == 313) then
       sqsu2=ecm-sqsl3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(4),m(7),x(4:5),p(:,4),p(:,7),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(6:7),q1,p(:,5),dl2)
       call kinff(imom,sqs3,m(3),m(6),x(8:9),p(:,3),p(:,6),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt163) then
       sqsl1=m(5)+m(7)
       sqsl2=m(4)+sqsl1
       sqsl3=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=p(:,4)+q1
        q3=p(:,3)+p(:,6)
       end if
       if (ikin == 314) then
       sqsu2=ecm-sqsl3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(6:7),p(:,4),q1,dl2)
       call kinff(imom,sqs3,m(3),m(6),x(8:9),p(:,3),p(:,6),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt164) then
       sqsl1=m(4)+m(5)
       sqsl2=sqsl1+m(7)
       sqsl3=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=q1+p(:,7)
        q3=p(:,3)+p(:,6)
       end if
       if (ikin == 315) then
       sqsu2=ecm-sqsl3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(3),m(6),x(8:9),p(:,3),p(:,6),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt165) then
       sqsl1=m(4)+m(5)
       sqsl2=m(7)+sqsl1
       sqsl3=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,7)+q1
        q3=p(:,3)+p(:,6)
       end if
       if (ikin == 316) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,me,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(7),sqs1,x(6:7),p(:,7),q1,dl2)
       call kinff(imom,sqs3,m(3),m(6),x(8:9),p(:,3),p(:,6),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt166) then
       sqsl1=m(4)+m(5)
       sqsl2=sqsl1+m(7)
       sqsl3=m(3)+m(6)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=q1+p(:,7)
        q3=p(:,3)+p(:,6)
       end if
       if (ikin == 317) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,me,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(3),m(6),x(8:9),p(:,3),p(:,6),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt170) then
       sqsl1=m(4)+m(5)
       sqsl2=m(3)+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,3)+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 318) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,me,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(6:7),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      end if
 
      end
