      module maxvals

      character(80), parameter :: prvrsn=
c Maximum values of some parameters for
     &         'carlomat, version 3.0 of 19 May, 2015'

      integer, parameter :: 
     &      nffb=60,         ! No of ffb vertices
     &      nbbb=30,         ! No of bbb vertices
     &      nbbbb=20,        ! No of bbbb vertices
     &      mxbb=10,         ! No of bb mixings
     &      ncol=3,          ! No of colours
     &      mxprt=100,       ! Max No of particles in a model
     &      mxepl=12,        ! Max No of external particles
     &      mxipl=200000,    ! Max No of intermediate particles
     &      mxvpl=6,         ! Max No of similar vertices, 
     &                       ! e.g. uua, uuz, uuh, uug
     &      mxmpl=5,         ! Max No of similar particle mixings,
     &                       ! e.g. arho0, aom0, aphi0
     &      mxmap=4          ! Max No of particles in a subsystem whose 
     &                       ! propagator should be mapped.
      integer, parameter :: 
     &      mxncnt=20,       ! Max No of continuation lines,
     &      mxcmdl=500,      ! Max No of lines in selected routines (e.g. 
     &                       ! mdkk*.f, mmodkk*.f) 
     &      mxcmdb=20,       ! Max No of blocks in selected routines (e.g. 
     &                       ! kin*kk*.f). Relevant for speeding up
     &                       ! their compilation.
     &      mxcmdc=20        ! No of colour factors to be computed in one
     &                       ! subroutine of colsqkk.f. Relevant for speeding 
     &                       ! up the compilation.

      real(kind(1.d0)), parameter :: rcold=1.d-12 ! accuracy for 
                                                  ! comparisons of the color 
                                                  ! factors

      end module maxvals

